function setupPage() {
    //Request Animation Frame
    var requestAnimationFrame = window.requestAnimationFrame ||
                                window.mozRequestAnimationFrame ||
                                window.webkitRequestAnimationFrame ||
                                window.msRequestAnimationFrame;
                                
    window.requestAnimationFrame = requestAnimationFrame;
    
    
    //Key Events
    window.keydown = {};

    function keyName(event) {
        return jQuery.hotkeys.specialKeys[event.which] ||
        String.fromCharCode(event.which).toLowerCase();
    }

    $(document).bind("keydown", function(event) {
        window.keydown[keyName(event)] = true;
    });

    $(document).bind("keyup", function(event) {
        window.keydown[keyName(event)] = false;
    });
};

function startAnimation(callback) {
	//Set up the timing information
    var fps = 0;
    var frameCount = 0;
    var startTime = new Date().getTime();
    var lastFPSUpdateTime = startTime;
    var lastFrameTime = startTime;

    //Start the main animation
    pulse();

    function pulse(time) {
        time = new Date().getTime();
    
        window.requestAnimationFrame(pulse);
        
        var timing = {
            fps: fps,
            totalTime: time-startTime,
            frameTime: time-lastFrameTime,
            currentTime: time
        }
        
        callback(timing);
        
        if(time - lastFPSUpdateTime >= 1000) {
            fps = frameCount;
            frameCount = 0;
            lastFPSUpdateTime = time;
        }
        
        frameCount++;
        lastFrameTime = time;
    }
}

function clamp(num, minimum, maximum) {
  return Math.min(Math.max(num, minimum), maximum);
};
