"use strict";

//Set up request Animation Frame
(function(){
    var requestAnimationFrame = window.requestAnimationFrame ||
                                window.mozRequestAnimationFrame ||
                                window.webkitRequestAnimationFrame ||
                                window.msRequestAnimationFrame;
                                
    window.requestAnimationFrame = requestAnimationFrame;
})();

function startAnimation(callback) {
	//Set up the timing information
    var fps = 0;
    var frameCount = 0;
    var startTime = new Date().getTime();
    var lastFPSUpdateTime = startTime;
    var lastFrameTime = startTime;

    //Start the main animation
    pulse();

    function pulse(time) {
        time = new Date().getTime();
    
        window.requestAnimationFrame(pulse);
        
        var timing = {
            fps: fps,
            totalTime: time-startTime,
            frameTime: time-lastFrameTime,
            currentTime: time
        }
        
        callback(timing);
        
        if(time - lastFPSUpdateTime >= 1000) {
            fps = frameCount;
            frameCount = 0;
            lastFPSUpdateTime = time;
        }
        
        frameCount++;
        lastFrameTime = time;
    }
}

function clamp(num, minimum, maximum) {
    return Math.min(Math.max(num, minimum), maximum);
};
