function getConvexHull(points) {
    var prev, current, lowest;
    var hull = [];
    
    //Find the lowest point and start with that (actually highest point)
    var index = 0;
    current = points[0];
    
    for(var i = 1; i < points.length; i++) {
        if(points[i][1] < current[1]) {
            index = i;
            current = points[i];
        }
    }
    points.splice(index,1);
    hull.push(current);
    lowest = current;
    
    prev = [current[0]-1, current[1]];
    
    while(points.length > 0) {
        var A = subAndNormalize(current, prev);
        
        var endCosine = dot(A, subAndNormalize(lowest, current));        
        
        index = 0;
        var B = subAndNormalize(points[0], current);
        var biggest = dot(A,B);
        
        for(var i = 1; i < points.length; i++) {
            
            var B = subAndNormalize(points[i], current);
            
            if(dot(A,B) > biggest) {
                index = i;
                biggest = dot(A,B);
            }
        }
        
        if(hull.length > 1 && endCosine >= biggest) {
            break;
        }
        prev = current;
        current = points[index];
        points.splice(index, 1);
        
        hull.push(current);
    }
    
    return hull;
}

function subAndNormalize(first, second) {
    var sub = [first[0]-second[0], first[1]-second[1]];
    var len = Math.sqrt(sub[0]*sub[0] + sub[1]*sub[1]);
    return [sub[0]/len, sub[1]/len];
}

function dot(first, second) {
    return first[0]*second[0] + first[1]*second[1];
}